## Fichier : EntrainementGenetic.py
# Auteur : Jovian Hersemeule

# Permet de lancer une session d'entraînement
# pour un réseau de neurones.

# Importations de fonctionnement
from ReseauNeurones import *
from ReseauNeurones.incubateur import Incubateur

from Outils.Moteur_de_jeu import *
from Outils.Moteur_de_jeu.Pathfinding import path_finding

from Outils import IA_alphabeta
from Outils.IA_alphabeta import IA_minmax_alpha_beta

# Différents tournois
from match_fonctionnels import tournoi # Toutes rondes ( IA )
nom_tournoi = "Toutes rondes"

##from match_fonctionnels import tournoi2 # Toutes rondes ( fonctions )
##nom_tournoi = "Toutes rondes"

##from match_fonctionnels import tournoi3 # Elimination directe
##nom_tournoi = "Elimination directe"

##from match_fonctionnels import rondes_suisses # Rondes suisses
##nom_tournoi = "Rondes suisses"

# Création
myTrainer = Incubateur()

myTrainer.save_rate = 2
myTrainer.tournoi = tournoi
myTrainer.nom_tournoi = nom_tournoi

# Paramètres d'entraînement
nom_structure = "PrimitifEfficace"
nom_session = "PurAleatoirePrecis1"
nb_gen_max = 300
nb_pop = 20
debug = True

if debug :
    from Outils.Moteur_de_jeu.Fenetre import Global
    from Outils.Moteur_de_jeu.Fenetre import affichage_sauvage

# Paramètres de génération
myTrainer.nb_elite_kept = 5
myTrainer.nb_elite_cross = 0
myTrainer.nb_mixte_cross = 0
myTrainer.nb_elite_mutate = 0
myTrainer.nb_weak_mutate = 0
myTrainer.nb_rd_generated = 15

# Lancement de l'entraînement
myTrainer.start_session(nom_structure, nom_session = nom_session, nb_gen_max = nb_gen_max, nb_pop = nb_pop, debug = debug )
