## Fichier : GeneteicGraph.py
# Auteur : Jovian Hersemeule

# Génénère des graphiques
# pour visualiser les progrès de
# l'algorithme génétique.

from Outils.Moteur_de_jeu import *
from Outils.Moteur_de_jeu.Partie import *

from Outils import IA_MinMax
from Outils.IA_MinMax import *

from ReseauNeurones import *
from ReseauNeurones.cerveau import *

# Deboguage
debug = True

# Joueur de référence
joueurRef

# Chargement d'un réseau
myBrain = Cerveau()
myBrain.charger_structure( "PrimitifEfficace.stc", debug = debug )
myBrain.charger_poids( "PurAleatoireFast2/Generation50/individu0.pds", debug = debug )
myBrain.build_network( debug = debug )

# Match
joueurA = IA_minmax("Genetic:Primitif", myBrain.fct_eval, 1 )
joueurB = Humain("Humain")

Global.partie = Partie(joueurA, joueurB, True, "")

vainqueur = Global.partie.demarrer()

# Annonce
print("J1 : ", joueurA.nom)
print("J2 : ", joueurB.nom)
print("Gagnant : ", vainqueur.nom)
